program shell_sort_masyvui;

const N=15;


var mas : array [1..N] of integer;

{ paprasto masyvo inicializacija }
procedure inicializuoti_mas;
  var i : integer;
begin
  for i := 1 to N do mas[i] := 0
end;

{ skaiciaus paprastam masyve suradimas }
function rasti_mas (sk : integer) : boolean;
  var i : integer;
      b : boolean;
begin
  b := false;
  for i := 1 to N do
    if mas[i] = sk then
    begin
      b := true;
      break
    end;
  rasti_mas := b
end;

{ paprasto masyvo uzpildymas }
procedure uzpildyti_mas;
  var i, val : integer;
begin
  inicializuoti_mas ();
  randomize;
  for i := 1 to N do
  begin
    repeat
      val := 1 + random (99)
    until not rasti_mas(val);
    mas[i] := val
  end
end;

{ paprasto masyvo atspausdinimas }
procedure spausdinti_mas;
  var i : integer;
begin
  for i := 1 to N do write (' ', mas[i]);
  writeln
end;


procedure shell_pradzioj (var a : array of integer);
    var i, j, v, h : integer;
begin

    h := 1;
    repeat h := 3*h+1 until h>N;
    
    repeat
    h := h div 3;

    for i := h  to N-1 do
    begin
        v:=a[i];
        j:=i;
        while (j >= h) and (a[j-h] > v) do
            begin
               a[j]:=a[j-h];
               j:=j-h;
            end;
        a[j]:= v;
        spausdinti_mas;
    end
    
    until h=1;
end;

      var    i : integer;

begin
  WriteLn('Labas. Kazka rusiuojam.');

  uzpildyti_mas ();
  writeln ('Nerusiuotas:');
  spausdinti_mas ();
  shell_pradzioj (mas);
  writeln;
  writeln ('Surusiuotas:');
  spausdinti_mas ();
  readln;
end.
